# $Id: solr.py 2969 2010-01-25 14:31:42Z anton $
# $URL: https://svn.non-gnu.uvt.nl/uvt-dev/tags/sources/meresco/bzv-9.3.0/src/solr.py $
from merescocore.framework import Observable
from lxml.etree import parse, tostring, ElementTree
from urllib import urlopen

class Solr(Observable):
    def __init__(self, url):
        Observable.__init__(self)
        self._solr_url = url

    def executeQuery(self, pyLuceneQuery, start=0, stop=10, sortBy=None, sortDescending=None, docfilter=None, **kwargs):
        url = self._solr_url+"?q="+str(pyLuceneQuery)

#        print url

        solrResponse = parse(urlopen(url))
        nrOfResults = int(solrResponse.xpath("/response/result/@numFound")[0])

#        print nrOfResults

        results = solrResponse.xpath("/response/result/doc/str/text()")

#        print results

        return nrOfResults, results
